/*----- PROTECTED REGION ID(AlarmNotifyClass.cpp) ENABLED START -----*/
//=============================================================================
//
// file :        AlarmNotifyClass.cpp
//
// description : C++ source for the AlarmNotifyClass.
//               A singleton class derived from DeviceClass.
//               It implements the command and attribute list
//               and all properties and methods required
//               by the AlarmNotify once per process.
//
// project :     Alarm Notify
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
//
// Elettra-Sincrotrone Trieste S.C.p.A. di interesse nazionale
// Strada Statale 14 - km 163,5 in AREA Science Park
// 34149 Basovizza, Trieste ITALY
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include <AlarmNotifyClass.h>

/*----- PROTECTED REGION END -----*/	//	AlarmNotifyClass.cpp

//-------------------------------------------------------------------
/**
 *	Create AlarmNotifyClass singleton and
 *	return it in a C function for Python usage
 */
//-------------------------------------------------------------------
extern "C" {
#ifdef _TG_WINDOWS_

__declspec(dllexport)

#endif

	Tango::DeviceClass *_create_AlarmNotify_class(const char *name) {
		return AlarmNotify_ns::AlarmNotifyClass::init(name);
	}
}

namespace AlarmNotify_ns
{
//===================================================================
//	Initialize pointer for singleton pattern
//===================================================================
AlarmNotifyClass *AlarmNotifyClass::_instance = NULL;

//--------------------------------------------------------
/**
 * method : 		AlarmNotifyClass::AlarmNotifyClass(string &s)
 * description : 	constructor for the AlarmNotifyClass
 *
 * @param s	The class name
 */
//--------------------------------------------------------
AlarmNotifyClass::AlarmNotifyClass(string &s):Tango::DeviceClass(s)
{
	cout2 << "Entering AlarmNotifyClass constructor" << endl;
	set_default_property();
	get_class_property();
	write_class_property();

	/*----- PROTECTED REGION ID(AlarmNotifyClass::constructor) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AlarmNotifyClass::constructor

	cout2 << "Leaving AlarmNotifyClass constructor" << endl;
}

//--------------------------------------------------------
/**
 * method : 		AlarmNotifyClass::~AlarmNotifyClass()
 * description : 	destructor for the AlarmNotifyClass
 */
//--------------------------------------------------------
AlarmNotifyClass::~AlarmNotifyClass()
{
	/*----- PROTECTED REGION ID(AlarmNotifyClass::destructor) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AlarmNotifyClass::destructor

	_instance = NULL;
}


//--------------------------------------------------------
/**
 * method : 		AlarmNotifyClass::init
 * description : 	Create the object if not already done.
 *                  Otherwise, just return a pointer to the object
 *
 * @param	name	The class name
 */
//--------------------------------------------------------
AlarmNotifyClass *AlarmNotifyClass::init(const char *name)
{
	if (_instance == NULL)
	{
		try
		{
			string s(name);
			_instance = new AlarmNotifyClass(s);
		}
		catch (bad_alloc &)
		{
			throw;
		}
	}
	return _instance;
}

//--------------------------------------------------------
/**
 * method : 		AlarmNotifyClass::instance
 * description : 	Check if object already created,
 *                  and return a pointer to the object
 */
//--------------------------------------------------------
AlarmNotifyClass *AlarmNotifyClass::instance()
{
	if (_instance == NULL)
	{
		cerr << "Class is not initialised !!" << endl;
		exit(-1);
	}
	return _instance;
}



//===================================================================
//	Command execution method calls
//===================================================================
//--------------------------------------------------------
/**
 * method : 		GetAlarmInfoClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *GetAlarmInfoClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "GetAlarmInfoClass::execute(): arrived" << endl;
	Tango::DevString argin;
	extract(in_any, argin);
	return insert((static_cast<AlarmNotify *>(device))->get_alarm_info(argin));
}


//===================================================================
//	Properties management
//===================================================================
//--------------------------------------------------------
/**
 *	Method      : AlarmNotifyClass::get_class_property()
 *	Description : Get the class property for specified name.
 */
//--------------------------------------------------------
Tango::DbDatum AlarmNotifyClass::get_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_prop.size() ; i++)
		if (cl_prop[i].name == prop_name)
			return cl_prop[i];
	//	if not found, returns  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method      : AlarmNotifyClass::get_default_device_property()
 *	Description : Return the default value for device property.
 */
//--------------------------------------------------------
Tango::DbDatum AlarmNotifyClass::get_default_device_property(string &prop_name)
{
	for (unsigned int i=0 ; i<dev_def_prop.size() ; i++)
		if (dev_def_prop[i].name == prop_name)
			return dev_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method      : AlarmNotifyClass::get_default_class_property()
 *	Description : Return the default value for class property.
 */
//--------------------------------------------------------
Tango::DbDatum AlarmNotifyClass::get_default_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_def_prop.size() ; i++)
		if (cl_def_prop[i].name == prop_name)
			return cl_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method      : AlarmNotifyClass::get_class_property()
 *	Description : Read database to initialize class property data members.
 */
//--------------------------------------------------------
void AlarmNotifyClass::get_class_property()
{
	/*----- PROTECTED REGION ID(AlarmNotifyClass::get_class_property_before) ENABLED START -----*/
	
	//	Initialize class property data members
	
	/*----- PROTECTED REGION END -----*/	//	AlarmNotifyClass::get_class_property_before
	//	Read class properties from database.
	cl_prop.push_back(Tango::DbDatum("MaxSearchSize"));
	cl_prop.push_back(Tango::DbDatum("SubscribePeriod"));
	
	//	Call database and extract values
	if (Tango::Util::instance()->_UseDb==true)
		get_db_class()->get_property(cl_prop);
	Tango::DbDatum	def_prop;
	int	i = -1;

	//	Try to extract MaxSearchSize value
	if (cl_prop[++i].is_empty()==false)	cl_prop[i]  >>  maxSearchSize;
	else
	{
		//	Check default value for MaxSearchSize
		def_prop = get_default_class_property(cl_prop[i].name);
		if (def_prop.is_empty()==false)
		{
			def_prop    >>  maxSearchSize;
			cl_prop[i]  <<  maxSearchSize;
		}
	}
	//	Try to extract SubscribePeriod value
	if (cl_prop[++i].is_empty()==false)	cl_prop[i]  >>  subscribePeriod;
	else
	{
		//	Check default value for SubscribePeriod
		def_prop = get_default_class_property(cl_prop[i].name);
		if (def_prop.is_empty()==false)
		{
			def_prop    >>  subscribePeriod;
			cl_prop[i]  <<  subscribePeriod;
		}
	}
	/*----- PROTECTED REGION ID(AlarmNotifyClass::get_class_property_after) ENABLED START -----*/
	
	//	Check class property data members init
	
	/*----- PROTECTED REGION END -----*/	//	AlarmNotifyClass::get_class_property_after

}

//--------------------------------------------------------
/**
 *	Method      : AlarmNotifyClass::set_default_property()
 *	Description : Set default property (class and device) for wizard.
 *                For each property, add to wizard property name and description.
 *                If default value has been set, add it to wizard property and
 *                store it in a DbDatum.
 */
//--------------------------------------------------------
void AlarmNotifyClass::set_default_property()
{
	string	prop_name;
	string	prop_desc;
	string	prop_def;
	vector<string>	vect_data;

	//	Set Default Class Properties
	prop_name = "MaxSearchSize";
	prop_desc = "Max size of search result";
	prop_def  = "5000";
	vect_data.clear();
	vect_data.push_back("5000");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		cl_def_prop.push_back(data);
		add_wiz_class_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_class_prop(prop_name, prop_desc);
	prop_name = "SubscribePeriod";
	prop_desc = "Period in seconds";
	prop_def  = "60";
	vect_data.clear();
	vect_data.push_back("60");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		cl_def_prop.push_back(data);
		add_wiz_class_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_class_prop(prop_name, prop_desc);

	//	Set Default device Properties
	prop_name = "HandlerList";
	prop_desc = "List of alarm handlers to manage";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "PropertyList";
	prop_desc = "List of free properties where to find alarm handlers to manage\nEx:\nAlarmHandler/DeviceList1\nAlarmHandler/DeviceList2";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "MaxSearchSize";
	prop_desc = "Max size of search result";
	prop_def  = "5000";
	vect_data.clear();
	vect_data.push_back("5000");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "Configuration";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "Receivers";
	prop_desc = "Alarm states and email addresses in the format\nAlarm states(comma separated): email addresses (comma separated);\nAlarm states 2(comma separated): email addresses 2 (comma separated);\n...";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "SubscribePeriod";
	prop_desc = "Period in seconds";
	prop_def  = "60";
	vect_data.clear();
	vect_data.push_back("60");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "GroupReceivers";
	prop_desc = "Each row Group and Alarm states and email addresses in the format\nGroupName=Alarm states(comma separated): email addresses (comma separated);\nAlarm states 2(comma separated): email addresses 2 (comma separated);\n...";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
}

//--------------------------------------------------------
/**
 *	Method      : AlarmNotifyClass::write_class_property()
 *	Description : Set class description fields as property in database
 */
//--------------------------------------------------------
void AlarmNotifyClass::write_class_property()
{
	//	First time, check if database used
	if (Tango::Util::_UseDb == false)
		return;

	Tango::DbData	data;
	string	classname = get_name();
	string	header;
	string::size_type	start, end;

	//	Put title
	Tango::DbDatum	title("ProjectTitle");
	string	str_title("Alarm Notify");
	title << str_title;
	data.push_back(title);

	//	Put Description
	Tango::DbDatum	description("Description");
	vector<string>	str_desc;
	str_desc.push_back("Alarm handler notifier");
	description << str_desc;
	data.push_back(description);

	//  Put inheritance
	Tango::DbDatum	inher_datum("InheritedFrom");
	vector<string> inheritance;
	inheritance.push_back("TANGO_BASE_CLASS");
	inher_datum << inheritance;
	data.push_back(inher_datum);

	//	Call database and and values
	get_db_class()->put_property(data);
}

//===================================================================
//	Factory methods
//===================================================================

//--------------------------------------------------------
/**
 *	Method      : AlarmNotifyClass::device_factory()
 *	Description : Create the device object(s)
 *                and store them in the device list
 */
//--------------------------------------------------------
void AlarmNotifyClass::device_factory(const Tango::DevVarStringArray *devlist_ptr)
{
	/*----- PROTECTED REGION ID(AlarmNotifyClass::device_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	AlarmNotifyClass::device_factory_before

	//	Create devices and add it into the device list
	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		cout4 << "Device name : " << (*devlist_ptr)[i].in() << endl;
		device_list.push_back(new AlarmNotify(this, (*devlist_ptr)[i]));
	}

	//	Manage dynamic attributes if any
	erase_dynamic_attributes(devlist_ptr, get_class_attr()->get_attr_list());

	//	Export devices to the outside world
	for (unsigned long i=1 ; i<=devlist_ptr->length() ; i++)
	{
		//	Add dynamic attributes if any
		AlarmNotify *dev = static_cast<AlarmNotify *>(device_list[device_list.size()-i]);
		dev->add_dynamic_attributes();

		//	Check before if database used.
		if ((Tango::Util::_UseDb == true) && (Tango::Util::_FileDb == false))
			export_device(dev);
		else
			export_device(dev, dev->get_name().c_str());
	}

	/*----- PROTECTED REGION ID(AlarmNotifyClass::device_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	AlarmNotifyClass::device_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : AlarmNotifyClass::attribute_factory()
 *	Description : Create the attribute object(s)
 *                and store them in the attribute list
 */
//--------------------------------------------------------
void AlarmNotifyClass::attribute_factory(vector<Tango::Attr *> &att_list)
{
	/*----- PROTECTED REGION ID(AlarmNotifyClass::attribute_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	AlarmNotifyClass::attribute_factory_before
	//	Attribute : alarmStatus
	alarmStatusAttrib	*alarmstatus = new alarmStatusAttrib();
	Tango::UserDefaultAttrProp	alarmstatus_prop;
	alarmstatus_prop.set_description("List of:\nalarm name - status - notification counter");
	//	label	not set for alarmStatus
	//	unit	not set for alarmStatus
	//	standard_unit	not set for alarmStatus
	//	display_unit	not set for alarmStatus
	//	format	not set for alarmStatus
	//	max_value	not set for alarmStatus
	//	min_value	not set for alarmStatus
	//	max_alarm	not set for alarmStatus
	//	min_alarm	not set for alarmStatus
	//	max_warning	not set for alarmStatus
	//	min_warning	not set for alarmStatus
	//	delta_t	not set for alarmStatus
	//	delta_val	not set for alarmStatus
	
	alarmstatus->set_default_properties(alarmstatus_prop);
	//	Not Polled
	alarmstatus->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(alarmstatus);

	//	Attribute : handlerStatus
	handlerStatusAttrib	*handlerstatus = new handlerStatusAttrib();
	Tango::UserDefaultAttrProp	handlerstatus_prop;
	handlerstatus_prop.set_description("List of:\nHandler Device Name = Tango State");
	//	label	not set for handlerStatus
	//	unit	not set for handlerStatus
	//	standard_unit	not set for handlerStatus
	//	display_unit	not set for handlerStatus
	//	format	not set for handlerStatus
	//	max_value	not set for handlerStatus
	//	min_value	not set for handlerStatus
	//	max_alarm	not set for handlerStatus
	//	min_alarm	not set for handlerStatus
	//	max_warning	not set for handlerStatus
	//	min_warning	not set for handlerStatus
	//	delta_t	not set for handlerStatus
	//	delta_val	not set for handlerStatus
	
	handlerstatus->set_default_properties(handlerstatus_prop);
	//	Not Polled
	handlerstatus->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(handlerstatus);

	//	Attribute : alarmReceivers
	alarmReceiversAttrib	*alarmreceivers = new alarmReceiversAttrib();
	Tango::UserDefaultAttrProp	alarmreceivers_prop;
	alarmreceivers_prop.set_description("List of:\nalarm name - alarm states: receivers; alarm state 2: receivers");
	//	label	not set for alarmReceivers
	//	unit	not set for alarmReceivers
	//	standard_unit	not set for alarmReceivers
	//	display_unit	not set for alarmReceivers
	//	format	not set for alarmReceivers
	//	max_value	not set for alarmReceivers
	//	min_value	not set for alarmReceivers
	//	max_alarm	not set for alarmReceivers
	//	min_alarm	not set for alarmReceivers
	//	max_warning	not set for alarmReceivers
	//	min_warning	not set for alarmReceivers
	//	delta_t	not set for alarmReceivers
	//	delta_val	not set for alarmReceivers
	
	alarmreceivers->set_default_properties(alarmreceivers_prop);
	//	Not Polled
	alarmreceivers->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(alarmreceivers);


	//	Create a list of static attributes
	create_static_attribute_list(get_class_attr()->get_attr_list());
	/*----- PROTECTED REGION ID(AlarmNotifyClass::attribute_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	AlarmNotifyClass::attribute_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : AlarmNotifyClass::pipe_factory()
 *	Description : Create the pipe object(s)
 *                and store them in the pipe list
 */
//--------------------------------------------------------
void AlarmNotifyClass::pipe_factory()
{
	/*----- PROTECTED REGION ID(AlarmNotifyClass::pipe_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	AlarmNotifyClass::pipe_factory_before
	/*----- PROTECTED REGION ID(AlarmNotifyClass::pipe_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	AlarmNotifyClass::pipe_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : AlarmNotifyClass::command_factory()
 *	Description : Create the command object(s)
 *                and store them in the command list
 */
//--------------------------------------------------------
void AlarmNotifyClass::command_factory()
{
	/*----- PROTECTED REGION ID(AlarmNotifyClass::command_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	AlarmNotifyClass::command_factory_before


	//	Command GetAlarmInfo
	GetAlarmInfoClass	*pGetAlarmInfoCmd =
		new GetAlarmInfoClass("GetAlarmInfo",
			Tango::DEV_STRING, Tango::DEVVAR_STRINGARRAY,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pGetAlarmInfoCmd);

	/*----- PROTECTED REGION ID(AlarmNotifyClass::command_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	AlarmNotifyClass::command_factory_after
}

//===================================================================
//	Dynamic attributes related methods
//===================================================================

//--------------------------------------------------------
/**
 * method : 		AlarmNotifyClass::create_static_attribute_list
 * description : 	Create the a list of static attributes
 *
 * @param	att_list	the ceated attribute list
 */
//--------------------------------------------------------
void AlarmNotifyClass::create_static_attribute_list(vector<Tango::Attr *> &att_list)
{
	for (unsigned long i=0 ; i<att_list.size() ; i++)
	{
		string att_name(att_list[i]->get_name());
		transform(att_name.begin(), att_name.end(), att_name.begin(), ::tolower);
		defaultAttList.push_back(att_name);
	}

	cout2 << defaultAttList.size() << " attributes in default list" << endl;

	/*----- PROTECTED REGION ID(AlarmNotifyClass::create_static_att_list) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AlarmNotifyClass::create_static_att_list
}


//--------------------------------------------------------
/**
 * method : 		AlarmNotifyClass::erase_dynamic_attributes
 * description : 	delete the dynamic attributes if any.
 *
 * @param	devlist_ptr	the device list pointer
 * @param	list of all attributes
 */
//--------------------------------------------------------
void AlarmNotifyClass::erase_dynamic_attributes(const Tango::DevVarStringArray *devlist_ptr, vector<Tango::Attr *> &att_list)
{
	Tango::Util *tg = Tango::Util::instance();

	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		Tango::DeviceImpl *dev_impl = tg->get_device_by_name(((string)(*devlist_ptr)[i]).c_str());
		AlarmNotify *dev = static_cast<AlarmNotify *> (dev_impl);

		vector<Tango::Attribute *> &dev_att_list = dev->get_device_attr()->get_attribute_list();
		vector<Tango::Attribute *>::iterator ite_att;
		for (ite_att=dev_att_list.begin() ; ite_att != dev_att_list.end() ; ++ite_att)
		{
			string att_name((*ite_att)->get_name_lower());
			if ((att_name == "state") || (att_name == "status"))
				continue;
			vector<string>::iterator ite_str = find(defaultAttList.begin(), defaultAttList.end(), att_name);
			if (ite_str == defaultAttList.end())
			{
				cout2 << att_name << " is a UNWANTED dynamic attribute for device " << (*devlist_ptr)[i] << endl;
				Tango::Attribute &att = dev->get_device_attr()->get_attr_by_name(att_name.c_str());
				dev->remove_attribute(att_list[att.get_attr_idx()], true, false);
				--ite_att;
			}
		}
	}
	/*----- PROTECTED REGION ID(AlarmNotifyClass::erase_dynamic_attributes) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AlarmNotifyClass::erase_dynamic_attributes
}

//--------------------------------------------------------
/**
 *	Method      : AlarmNotifyClass::get_attr_object_by_name()
 *	Description : returns Tango::Attr * object found by name
 */
//--------------------------------------------------------
Tango::Attr *AlarmNotifyClass::get_attr_object_by_name(vector<Tango::Attr *> &att_list, string attname)
{
	vector<Tango::Attr *>::iterator it;
	for (it=att_list.begin() ; it<att_list.end() ; ++it)
		if ((*it)->get_name()==attname)
			return (*it);
	//	Attr does not exist
	return NULL;
}


/*----- PROTECTED REGION ID(AlarmNotifyClass::Additional Methods) ENABLED START -----*/

/*----- PROTECTED REGION END -----*/	//	AlarmNotifyClass::Additional Methods
} //	namespace
